//shading:         constant color
//lighting model:  none
//lighting type:   none

// --------------------------------------------------------------------------------------------------
// PARAMETERS:
// --------------------------------------------------------------------------------------------------

//transforms
float4x4 tW: WORLD;        //the models world matrix
float4x4 tV: VIEW;         //view matrix as set via Renderer (EX9)
float4x4 tP: PROJECTION;   //projection matrix as set via Renderer (EX9)
float4x4 tWVP: WORLDVIEWPROJECTION;

//material properties
float4 cAmb : COLOR <String uiname="Color";>  = {1, 1, 1, 1};
float Alpha = 1;


//texture
texture Tex <string uiname="Texture";>;
sampler Samp = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (Tex);          //apply a texture to the sampler
    MipFilter = LINEAR;         //sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

 float4x4 tTex: TEXTUREMATRIX <string uiname="Texture Transform";>;





float2 center  <String uiname="Center" ;int uimin=0;int uimax=1;  >  = {0.5, 0.5};
float hor  <String uiname="Horizontal" ;float uimin=0;float uimax=1;  >  = {0};
float ver  <String uiname="Vertical" ;float uimin=0;float uimax=1;  >  = {0};
float blend  <String uiname="Blend" ;float uimin=0;float uimax=1;  >  = {0.5};
float boost <String uiname="Boost" ;float uimin=0;float uimax=1;  >  = {0.5};

float displacement <String uiname="Displacement" ;  >  = {0};
float2 Pixel <string uiname="Resolution"; float uistep=1;> = {512,512};



//the data structure: "vertexshader to pixelshader"
//used as output data with the VS function
//and as input data with the PS function
struct vs2ps
{
    float4 Pos : POSITION;
    float4 TexCd : TEXCOORD0;
};

// --------------------------------------------------------------------------------------------------
// VERTEXSHADERS
// --------------------------------------------------------------------------------------------------

vs2ps VS(
    float4 Pos : POSITION,
    float4 TexCd : TEXCOORD0,
    float4 TexCddispla : TEXCOORD1)
{
    //inititalize all fields of output struct with 0
    vs2ps Out = (vs2ps)0;
    float4 orig = mul(float4(0, 0, 0, 1), tW);
    
    
        float4 lookup;
    lookup = mul(TexCd, tTex);
    lookup.w = 0;
    float4 tx = tex2Dlod(Samp,lookup);  //here is load the heightmap texture


    
     TexCd *=  1-tx.x * 0;
    
    //transform position
    Out.Pos = mul(Pos, tWVP);

    //transform texturecoordinates
    Out.TexCd = mul(TexCd, tTex);

    return Out;
}


//       _________________________________________________________________________________
//       <   FUNCTIONS    >
//       
//          _____
//       __/  1  \________________________________________________________________________
//       
         float MaxCol (float4 ColorIn )
               {
               float maxRGB  = max ( max (  ColorIn.r , ColorIn.g ) , ColorIn.b ) ;
               return maxRGB;
               }
//       
//                 _____
//       _________/  2  \__________________________________________________________________
//       
         float MinCol (float4 ColorIn )
               {
               float minRGB  = min ( min (  ColorIn.r , ColorIn.g ) , ColorIn.b ) ;
               return minRGB;
               }
//       
//                        _____
//       ________________/  3  \___________________________________________________________
//       
//       credits to Rob Galanakis   ---  http://www.robg3d.com/commonFunctions.html
         float GetLuminance (float4 ColorIn )
               {
                float maxRGB  = max ( max (  ColorIn.r , ColorIn.g ) , ColorIn.b ) ;
                float minRGB  = min ( min (  ColorIn.r , ColorIn.g ) , ColorIn.b ) ;
                float Luminance = ((maxRGB + minRGB)/2);
                return Luminance;
               }
//       
//                               _____
//       _______________________/  4  \____________________________________________________
//       
//       credits to Rob Galanakis   ---  http://www.robg3d.com/commonFunctions.html
         float CheapLuminance (float4 ColorIn)
               {
               float3 LuminanceCoefficient = (0.299,0.587,0.114);
               float Luminance = dot(ColorIn, LuminanceCoefficient);
               return Luminance;
               }
 //       
         float4 QuantizeRGB ( float4 InColor , int Steps ,float lo, float hi)
               {
               float4 OutColor  = InColor ;
                      OutColor.rgb  *=  Steps  ;

                      OutColor.r   =  ceil ( OutColor.r )  ;
                      OutColor.g   =  ceil ( OutColor.g )  ;
                      OutColor.b   =  ceil ( OutColor.b )  ;

                      OutColor.rgb  /=  Steps  ;
                      OutColor.r  =  lerp(lo,hi ,OutColor.r) ;
                      OutColor.g  =  lerp(lo,hi ,OutColor.g) ;
                      OutColor.b  =  lerp(lo,hi ,OutColor.b) ;
               return OutColor;
               }
//       


// --------------------------------------------------------------------------------------------------
// PIXELSHADERS:
// --------------------------------------------------------------------------------------------------

float4 ClampFade (vs2ps In): COLOR
{
    //In.TexCd = In.TexCd / In.TexCd.w; // for perpective texture projections (e.g. shadow maps) ps_2_0

   float4 col = tex2D(Samp, In.TexCd);//,
   
  float2 px = Pixel;
float InvScreenW = 1/ -Pixel.x;
float InvScreenH = 1/ -Pixel.y;
   
     float4 _11 = col-tex2D(Samp, In.TexCd + float2(-InvScreenW, -InvScreenH));
  float4 _12 = col-tex2D(Samp, In.TexCd + float2(            0, -InvScreenH));
  float4 _13 = col-tex2D(Samp, In.TexCd + float2( InvScreenW, -InvScreenH));
  float4 _21 = col-tex2D(Samp, In.TexCd + float2(-InvScreenW,             0));
  float4 _23 = col-tex2D(Samp, In.TexCd + float2( InvScreenW,             0));
  float4 _31 = col-tex2D(Samp, In.TexCd + float2(-InvScreenW,  InvScreenH));
  float4 _32 = col-tex2D(Samp, In.TexCd + float2(            0,  InvScreenH));
  float4 _33 = col-tex2D(Samp, In.TexCd + float2( InvScreenW,  InvScreenH));
   

  //
   
   float mmin = min ( min (col.r, col.g),col.b);
   float mmax = max ( max (col.r, col.g),col.b);
   float saturation =  (mmax-mmin)/(mmax+mmin);
 	              if   ( mmax-mmin <0.05 || mmax+mmin < 0.05 )  { saturation = 0.0;  }
   
   float2 verUV = float2(In.TexCd.x,1-center.y );
   float2 horUV = float2(center.x , In.TexCd.y);
            mmin= 1-mmin;
            mmin*=  boost;
         mmax*=  boost;

   float fade = mmin;//


   float2 ShiftUV =   float2(
                             displacement
                                        *   InvScreenW
                                        *  min (
                                                distance(col.rgb,_21.rgb),
                                                distance(col.rgb,_23.rgb)
                                                )
                                        *  sign (
                                                distance(col.rgb,_21.rgb)-
                                                distance(col.rgb,_23.rgb)
                                                )
                                                 ,
                              displacement
                                        *   InvScreenH
                                        *  min (
                                                distance(col.rgb,_12.rgb),
                                                distance(col.rgb,_32.rgb)
                                                )
                                        *  -sign (
                                                distance(col.rgb,_32.rgb)-
                                                distance(col.rgb,_12.rgb)
                                                )
                             );

   float2 fuckUV = float2(  0.5*In.TexCd.x +.25 ,0.5*In.TexCd.y +.25  );
   float2 dist =fuckUV -In.TexCd;
   float2 normd = normalize(dist);
   
   
   // float2 fuckUV = float2(   (1-fade)*In.TexCd.x +fade/2 ,( 1-fade)*In.TexCd.y +fade/2  );
   float4 Hcol = tex2D(Samp, horUV)*hor;
   float4 Vcol = tex2D(Samp, verUV)*ver;
   float4 Scol = col;
    int i;
       for (i = 1; i < 28; i++)
    {
   Scol.rgb = saturate( lerp (
                         clamp(min(    Scol.rgb,
                                 tex2D(Samp,  In.TexCd - ShiftUV * float2(i,i)).rgb) ,0.01,0.99) ,
                        clamp(max(    Scol.rgb,
                                 tex2D(Samp,  In.TexCd - ShiftUV * float2(i,i)).rgb),0.01,0.99) ,
                                 boost)


                                 );
   //Scol.rgb /= 2;
   }
  // float4 Scol = tex2D(Samp,lerp(In.TexCd, ShiftUV,fade)) ;
   
              //Vcol*= saturate(lerp( MinCol ( Vcol ) ,MaxCol ( Vcol ),ver) );
             // Hcol*= lerp( MinCol ( Hcol ) ,MaxCol ( Hcol ),hor) ;
    //col = max(  max(   Hcol ,Vcol ) ,    col   );
    
    
    
    // col = lerp( col,Scol, boost);//
     col.rgb = lerp(   (Hcol.rgb+Vcol.rgb)*max (hor,ver)  ,    Scol.rgb   , blend  );
     
     
    // col.rgb= _23.rgb+_21.rgb;
    //col = min ( min(col,tex2D(Samp, horUV))       , tex2D(Samp, verUV) );
    //col = max ( max(col,tex2D(Samp, horUV))       , tex2D(Samp, verUV) );
    //col = max ( lerp(col,tex2D(Samp, horUV),hor)       , lerp(col,tex2D(Samp, verUV),ver) );
    col *= cAmb;
    col.a *= Alpha;
    return col;
}





// --------------------------------------------------------------------------------------------------
// TECHNIQUES:
// --------------------------------------------------------------------------------------------------

technique ClampFade
{
    pass P0
    {
        //Wrap0 = U;  // useful when mesh is round like a sphere
        VertexShader = compile vs_3_0 VS();
        PixelShader = compile ps_3_0 ClampFade ();
    }
}
